#include "tso_pre_include.h"
#include "tso_test_framework.h"
#include "tso_shared.h"

struct tso_functions functions;

int nic_revision;
unsigned long iters = 1000;
unsigned long seed;
int verbose = 0;
int clean_headers = 0; /* For pktdump don't fill header with random data */
int do_hex_dump = 0;
int do_dump_tx_queue = 0;
int tcp_rand_pay_in_skb = 0;/* Payload in the linear part of the skb */
int tcp_no_urg = 1;
int tcp_no_rst = 1;
int tcp_no_syn = 1;

void my_free(void *ptr)
{
	functions.user_free(ptr);
}
void my_fail(const char *fmt, ...)
{
	va_list ap;
	va_start(ap, fmt);
	functions.user_vfail(fmt, ap);
	va_end(ap);
}
void *my_calloc(size_t nmemb, size_t size)
{
	return functions.user_calloc(nmemb, size);
}
void *my_malloc(size_t size)
{
	return functions.user_malloc(size);
}
int my_puts(const char *s)
{
	return functions.user_puts(s);
}
int my_printf(const char *fmt, ...)
{
	int r;
	va_list ap;
	va_start(ap, fmt);
	r = functions.user_vprintf(fmt, ap);
	va_end(ap);
	return r;
}
void my_netdev_printk(const char *level, const char *format, ...)
{
	va_list ap;
	va_start(ap, format);
	functions.user_netdev_vprintk(level, format, ap);
	va_end(ap);
}
int my_memcmp(const void *s1, const void *s2, size_t n)
{
	return functions.user_memcmp(s1, s2, n);
}
void *my_memcpy(void *dest, const void *src, size_t n)
{
	return functions.user_memcpy(dest, src, n);
}

