#ifndef TSO_SHARED
#define TSO_SHARED

struct tso_functions {
	__attribute__ ((regparm(0))) void *(*user_calloc)(size_t nmemb, size_t size);
	__attribute__ ((regparm(0))) void *(*user_malloc)(size_t size);
	__attribute__ ((regparm(0))) void (*user_free)(void *ptr);
	__attribute__ ((regparm(0))) int (*user_puts)(const char *s);
	__attribute__ ((regparm(0))) int (*user_vprintf)(const char *fmt, va_list ap);
	__attribute__ ((regparm(0))) void (*user_vfail)(const char *fmt, va_list ap);
	__attribute__ ((regparm(0))) void (*user_netdev_vprintk)(const char *level, const char *format, va_list ap);
	__attribute__ ((regparm(0))) int (*user_memcmp)(const void *s1, const void *s2, size_t n);
	__attribute__ ((regparm(0))) void *(*user_memcpy)(void *dest, const void *src, size_t n);
};
extern struct tso_functions functions;

extern int do_test(void);

/* only to be called from kernel module side */
extern void *my_malloc(size_t size);
extern void *my_calloc(size_t nmemb, size_t size);
extern void my_free(void *ptr);
extern void my_fail(const char *format, ...);
extern void my_netdev_printk(const char *level, const char *format, ...);
extern int my_printf(const char *format, ...);
extern int my_memcmp(const void *s1, const void *s2, size_t n);
extern void *my_memcpy(void *dest, const void *src, size_t n);

/* config */
extern int nic_revision;
extern unsigned long iters;
extern unsigned long seed;
extern int verbose;
extern int clean_headers; /* For pktdump don't fill header with random data */
extern int do_hex_dump;
extern int do_dump_tx_queue;
extern int tcp_rand_pay_in_skb;/* Payload in the linear part of the skb */
extern int tcp_no_urg;
extern int tcp_no_rst;
extern int tcp_no_syn;

#endif

