Name:		sfc-dkms
Version:	
Release:	0.sf.1
Epoch:		0

Summary:	Solarflare SFN5XXX|6XXX|7XXX|8XXX|X2 network adapter device driver

Group:		System Environment/Kernel
Vendor:		Solarflare Communications
License:	GPL
URL:		http://www.solarflare.com/

BuildArch:	noarch
Requires:	dkms >= 2.00
Requires:	binutils, gcc, make
Source0:	sfc-%{version}.dkms.tar.gz
Source1:	sfc.conf
BuildRoot:	%{_tmppath}/sfc-%{version}-%{release}-root-%(%{__id_u} -n)/

%description
The Linux kernel driver for Solarflare SFN5XXX|6XXX|7XXX|8XXX|X2 Ethernet
controllers.

This is a DKMS (Dynamic Kernel Module System) package and requires
dkms to be installed.

For a list of supported Solarflare products, please consult the release
notes and the user guide available from https://support.solarflare.com/.

%prep
rm -rf sfc-dkms-%{version}
mkdir sfc-dkms-%{version}
cp "$RPM_SOURCE_DIR"/sfc-%{version}.dkms.tar.gz sfc-dkms-%{version}/
cd sfc-dkms-%{version} && tar xzf sfc-%{version}.dkms.tar.gz ./dkms_source_tree

%install
if [ "$RPM_BUILD_ROOT" != "/" ]; then
	rm -rf "$RPM_BUILD_ROOT"
fi
mkdir -p "$RPM_BUILD_ROOT"/usr/src/sfc-dkms-%{version}
cp sfc-dkms-%{version}/sfc-%{version}.dkms.tar.gz \
	"$RPM_BUILD_ROOT"/usr/src/sfc-dkms-%{version}/
mkdir -p "$RPM_BUILD_ROOT"/usr/share/doc/sfc-dkms-%{version}
for doc in LICENSE README; do
	cp sfc-dkms-%{version}/dkms_source_tree/$doc \
		"$RPM_BUILD_ROOT"/usr/share/doc/sfc-dkms-%{version}/
done
install -dm 755 $RPM_BUILD_ROOT%{_sysconfdir}/depmod.d
install -pm 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_sysconfdir}/depmod.d/sfc.conf

%clean
if [ "$RPM_BUILD_ROOT" != "/" ]; then
	rm -rf "$RPM_BUILD_ROOT"
fi
rm -rf sfc-dkms-%{version}

%files
%defattr(-,root,root)
/usr/src/sfc-dkms-%{version}/
/usr/share/doc/sfc-dkms-%{version}/
%{_sysconfdir}/depmod.d/sfc.conf

%pre

%post
dkms ldtarball --archive /usr/src/sfc-dkms-%{version}/sfc-%{version}.dkms.tar.gz

if ! uname -r | grep -q "BOOT" && [ -e /lib/modules/`uname -r`/build/include ]; then
	dkms build -m sfc -v %{version}
	dkms install --force -m sfc -v %{version}
elif uname -r | grep -q "BOOT"; then
	echo -e ""
	echo -e "Module build for the currently running kernel was skipped since you"
	echo -e "are running a BOOT variant of the kernel."
else
	echo -e ""
	echo -e "Module build for the currently running kernel was skipped since the"
	echo -e "kernel source for this kernel does not seem to be installed."
fi
exit 0

%preun
echo -e
echo -e "Uninstall of sfc module (version %{version}) beginning:"
dkms remove -m sfc -v %{version} --all --rpm_safe_upgrade
exit 0
