%define pkgversion 4.9.0.1016
%if %{?kversion: 1}%{!?kversion: 0}
%define kernel_version %{kversion}
%endif

Name:           solarflare-sfc
Version:        %{pkgversion}
Release:        1
Epoch:          0

Summary:        Solarflare SFN5XXX|6XXX|7XXX|8XXX network adapter device driver

Group:          System/Kernel
License:        GPL
URL:            http://www.solarflare.com/
Vendor:		Solarflare Communications

Source0:        sfc-%{version}.tar.gz
Source1:        files.el6

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  %{?kernel_module_package_buildreqs: %{expand: %%{kernel_module_package_buildreqs}}}%{!?kernel_module_package_buildreqs: kernel-source kernel-syms}

%description
The Linux kernel driver for Solarflare SFC9000-family Ethernet controllers.

This is a KMP (Kernel Module Package) for use with SLE 10/11,
OpenSUSE 10.1+ and RHEL 5/6.

For a list of supported Solarflare products, please consult the release
notes and the user guide available from https://support.solarflare.com/.

%kernel_module_package -f %{_sourcedir}/files.el6 -x um vmi vmipae

%define install_mod_dir extra/%{name}

%prep
%setup -q -n sfc-%{version}

%build
cd "$RPM_BUILD_DIR/sfc-%{version}"
mkdir -p obj

for flavor in %{flavors_to_build}; do
  rm -rf obj/$flavor
  cp -R linux_net obj/$flavor

%if %{?kernel_source: 1}%{!?kernel_source: 0}
  # RHEL5
  kpath=%{kernel_source $flavor}
%else
  # SLE
  kpath=/usr/src/linux-obj/%{_target_cpu}/$flavor
%endif

  %{__make} -j4 -C obj/$flavor KPATH=$kpath NDEBUG=1 KMP_RELEASE=1 modules
done

%install
cd "$RPM_BUILD_DIR/sfc-%{version}"
for flavor in %{flavors_to_build}; do

kpath=%{kernel_source $flavor}
  %{__make} -C obj/$flavor INSTALL_MOD_PATH="${RPM_BUILD_ROOT}" INSTALL_MOD_DIR=%{install_mod_dir} KPATH=$kpath  NDEBUG=1 modules_install
done

%clean
%{__rm} -rf $RPM_BUILD_ROOT
