# This will cause "error: line X: Unknown tag:" if the KMOD/KMP macros are missing
%{!?kernel_module_package: kernel_module_package RPM macro is missing. For RHEL/SLE please install the 'kernel-rpm-macros' RPM}

Name: solarflare-sfc
Summary: Solarflare SFN5XXX|6XXX|7XXX|8XXX|X2 network adapter device driver
Version: %{pkgversion}
Release: 3.1
Source: %{name}-%{version}.tar.bz2
#Source1: files.el6
License: GPL
Group: System/Kernel
URL: http://www.solarflare.com/
BuildRequires: %kernel_module_package_buildreqs
BuildRoot: %{_tmppath}/%{name}-%{version}-root
%kernel_module_package -x debug -x trace

%description
The Linux kernel driver for Solarflare SFN5XXX|6XXX|7XXX|8XXX|X2 Ethernet
controllers.

For a list of supported Solarflare products, please consult the release
notes and the user guide available from https://support.solarflare.com/.

Group: System/Kernel

# %description KMP
# This package contains the Linux driver for the Solarflare SFC4000 and SFC9000-family of 10G Ethernet controllers

%prep
%setup
set -- *
mkdir source
mv "$@" source/
echo "sfc.ko external" > source/Module.supported
mkdir obj

%build
export EXTRA_CFLAGS='-DVERSION="%version"'
for flavor in %flavors_to_build; do
    rm -rf obj/$flavor
    cp -r source obj/$flavor
    make -C %{kernel_source $flavor} modules M=$PWD/obj/$flavor
done

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=updates
for flavor in %flavors_to_build; do
    make -C %{kernel_source $flavor} modules_install M=$PWD/obj/$flavor
done

#%clean
#rm -rf %{buildroot}

#%files
#%defattr(-,root,root)
#%doc source/README

%changelog
* Mon Feb 11 2019 lance.ortiz@suse.com
-Added version 4.15.1.1008 and provide build for SLE15
* Tue Jul 29 2014 poswald@suse.com
-Initial KMP build of the sfc v4.1.0.6734
