# This will cause "error: line X: Unknown tag:" if the KMOD/KMP macros are missing
%{!?kernel_module_package: kernel_module_package RPM macro is missing. For RHEL/SLE please install the 'kernel-rpm-macros' RPM}

%if %{?kversion: 1}%{!?kversion: 0}
%define kernel_version %{kversion}
%endif

Name:           solarflare-sfc
Version:        %{pkgversion}
Release:        1
Epoch:          0

Summary:        Solarflare SFN5XXX|6XXX|7XXX|8XXX|X2 network adapter device driver

Group:          System/Kernel
License:        GPL
URL:            http://www.solarflare.com/
Vendor:		Solarflare Communications

Source0:        sfc-%{version}.tar.gz
Source1:        files.el6
Source2:        rhel5-kmodtool-wrapper

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  %{?kernel_module_package_buildreqs: %{expand: %%{kernel_module_package_buildreqs}}}%{!?kernel_module_package_buildreqs: kernel-source kernel-syms}

%description
The Linux kernel driver for Solarflare SFN5XXX|6XXX|7XXX|8XXX|X2 Ethernet
controllers.

This is a KMP/KMOD package for use with SLES and RHEL.

For a list of supported Solarflare products, please consult the release
notes and the user guide available from https://support.solarflare.com/.

%if %{?kernel_module_package: 1}%{!?kernel_module_package: 0}
# SLES10 vs SLES11
%if %{?sles_version: 1}%{!?sles_version: 0}
# SLES11 has the macro defined
%kernel_module_package -x um vmi vmipae
%else

# RHEL5 vs. RHEL6
%if %{?rhel: 0}%{!?rhel: 1}
%kernel_module_package -s %{_sourcedir}/rhel5-kmodtool-wrapper -x um vmi vmipae
%else
%kernel_module_package -f %{_sourcedir}/files.el6 -x um vmi vmipae
%endif

%endif
%elseif %{?suse_kernel_module_package: 1}%{!?suse_kernel_module_package: 0}
# definitely sles
%suse_kernel_module_package um vmi vmipae
%endif

%if %{?sles_version: 1}%{!?sles_version: 0}
%define install_mod_dir updates
%else
%define install_mod_dir extra/%{name}
%endif

%prep
%setup -q -n sfc-%{version}

%build
cd "$RPM_BUILD_DIR/sfc-%{version}"
mkdir -p obj

for flavor in %{flavors_to_build}; do
  rm -rf obj/$flavor
  cp -R linux_net obj/$flavor

%if %{?kernel_source: 1}%{!?kernel_source: 0}
  # RHEL5
  kpath=%{kernel_source $flavor}
%else
  # SLE
  kpath=/usr/src/linux-obj/%{_target_cpu}/$flavor
%endif

  %{__make} -j4 -C obj/$flavor KPATH=$kpath NDEBUG=1 KMP_RELEASE=1 modules
done

%install
cd "$RPM_BUILD_DIR/sfc-%{version}"
for flavor in %{flavors_to_build}; do

%if %{?kernel_source: 1}%{!?kernel_source: 0}
  # RHEL5
  kpath=%{kernel_source $flavor}
%else
  # SLE
  kpath=/usr/src/linux-obj/%{_target_cpu}/$flavor
%endif

  %{__make} -C obj/$flavor INSTALL_MOD_PATH="${RPM_BUILD_ROOT}" INSTALL_MOD_DIR=%{install_mod_dir} KPATH=$kpath  NDEBUG=1 modules_install
done
# if not on sles
%if %{?sles_version: 0}%{!?sles_version: 1}
mkdir -p "$RPM_BUILD_ROOT/etc/depmod.d"
echo "override sfc * weak-updates/%{name}" > "$RPM_BUILD_ROOT/etc/depmod.d/sfc.conf"
%endif

%clean
%{__rm} -rf $RPM_BUILD_ROOT
